Attribute VB_Name = "Module1"
'********************************************************************
'Declarations               all public variables dimensioned here
'********************************************************************

Public Status As Byte
Public portb As Byte             'portb on the servo card
                                 'this register keeps track
                                 'of the state of the register
                                 'so subsequent commands can
                                 'write in using a masked
                                 'write
Public Port_A_DIO As Byte        'Port A on the DIO-96 card

Public signalhi(0 To 1) As Byte
Public signallo(0 To 1) As Byte

Public byte_parameter_array(0 To 3) As Byte

Public Desired_Velocity_Main As Long
Public Desired_Position_Main As Long
Public Indexer_Position_Main As Long
Public Counts_Per_Turn_Main As Long       'Indexer counts per turn variable

Public Desired_Position_Polish As Long
Public Indexer_Position_Polish As Long
Public Counts_Per_Turn_Polish As Long

Public Acceleration_Main As Long          'Main Traj Axis Parameters
Public Velocity_Main As Long
Public Position_Main As Long
Public Toggle_Pos_Main As Long


Public Acceleration_Polish As Long         'Polishing Axis Traj Parameters
Public Velocity_Polish As Long
Public Position_Polish As Long
Public Toggle_Pos_Polish As Long


Public DClock_Main As Byte                 'Main Axis Filter Para
Public Proportional_Main As Long
Public Integral_Main As Long
Public Derivative_Main As Long
Public ILimit_Main As Long

Public DClock_Polish As Byte               'Polish Axis Filter Para
Public Proportional_Polish As Long
Public Integral_Polish As Long
Public Derivative_Polish As Long
Public ILimit_Polish As Long

Public Real_Position_Main As Long
Public Real_Position_Polish As Long

Public seek_home_main_flag As Boolean      'Main Axis
Public run_main_flag As Boolean            'flags
Public found_home_main_flag As Boolean
Public stop_passed_main_flag As Boolean
Public dither_main_stroke_flag As Boolean

Public seek_home_polish_flag As Boolean    'Main Axis
Public run_polish_flag As Boolean          'homing flags
Public found_home_polish_flag As Boolean
Public stop_passed_polish_flag As Boolean

Public run_rotary_axis_flag As Boolean     'rotary axis run flag
Public rotary_move_done_flag As Boolean    'move done indicator
Public Rotary_Integer_Ratio As Long        'stroke to rotary move ratio
Public Rotary_Run_Interval As Long         'run interval on intermittant setting



Public apply_abrasive_flag As Boolean      'abrasive flags
Public apply_done_bank_0_flag As Boolean
Public apply_done_bank_1_flag As Boolean

Public Application_Interval_0 As Long
Public Application_Interval_1 As Long
Public Abrasive_Application_Start_Position As Long
Public Manual_Application_Bank_0_Interval  As Long
Public Manual_Application_Bank_1_interval  As Long


Public Stroke_Counter As Long
Public Run_Duration As Long

Public emulation_flag As Boolean           'emulation flag disables busybit checking to allow testing
                                           'without servo card installed
'end of declaration block

'********************************************************************
Private Sub Main()     'all Public variables initialized here
'********************************************************************

portb = &HFF                      'added to keep track of *PS line value
  
seek_home_main_flag = False       'initialize main axis
found_home_main_flag = False      'flags
run_main_flag = False
stop_passed_main_flag = False
dither_main_stroke = False

seek_home_polish_flag = False     'initialize polish axis
found_home_polish_flag = False    'flags
run_polish_flag = False
stop_passed_polish_flag = False

run_rotary_axis_flag = False      'initialize rotary axis
                                  'flag

apply_abrasive_flag = False
apply_done_bank_0_flag = True
apply_done_bank_1_flag = True


Application_Interval_0 = 24                 'default value .2 second
Application_Interval_1 = 24
Manual_Application_Bank_0_Interval = 50     'interrupt interval=1 shot duration
Manual_Application_Bank_1_interval = 50     'used for manual application buttons
Abrasive_Application_Start_Position = 33000 / 2


Stroke_Counter = 0             'at power up stroke count=0
Run_Duration = 10000           'set for 2 hours default

Rotary_Integer_Ratio = 1       'default stroke/rotary move count=2
Rotary_Run_Interval = 1000     'default time= 1 second
rotary_move_done_flag = False  'initialize to not done





Gear_Ratio = 5                 'gear ratio
Counts_Per_Turn_Main = 4000    'Main Axis count per revolution (4*1000)
Counts_Per_Turn_Polish = 4000  'Polish Axis count per revolution (4*1000)


        '********emulation mode variables*************
        
emulation_flag = False         'for software testing without servo card installed / busybit checking disabled

        '********hardware inits below here**********
initDIO                        'config DIO card
reset                          'reset LM628 both channels

                     '****initialize 8254 timer chip
                         
                        '*on servo card
                     
HW_Timer_Interval_Write 0, Application_Interval_0, 0    'hardware_timer=0 / mode=1(prog one shot)
                                     'default value hardware timer_0 = 200 mS
HW_Timer_Interval_Write 1, Application_Interval_1, 0    'hardware_timer=1 / mode=1(prog one shot)
                                                        'default value hardware timer_1 = 200 mS
HW_Timer_Interval_Write 2, 200, 0                       'hardware_timer=2 / mode=1(one shot)
                                


Rotary_Drive_Switch "off"

xMain.Show                           'load xMain form and show it

End Sub

'*********************************************************************************************
Public Sub HW_Timer_Interval_Write(timer_number As Byte, interval As Long, mode As Byte)
'*********************************************************************************************

Dim hi As Byte, lo As Byte
Dim command_byte As Byte

        '****command bytes***
command_byte = &H30 + timer_number * 2 ^ 6 + mode * 2  'mask in the timer# and mode
Out &H187, command_byte                  'address &h187 on servo card


        '****interval lo and hi byte****
hi = CByte(interval \ 256)               'gen hi byte
lo = CByte(interval - CLng(hi) * 256)    'gen low byte
    
Out (&H184 + timer_number), lo            'write lo byte
Out (&H184 + timer_number), hi            'write hi byte


End Sub





'*******************************************************
Public Sub initDIO()
'*******************************************************
   'this routine now initializes the single 8255
   'on the prototype ISA board
   
Out &H183, &HC1  ' PIA cfg: mode 1 port A is bi, port B output,
                 ' and port C is control lines with pc4&pc6 outputs
                 ' pc4 is the input strobe..."STB".... from peripheral
                 ' pb6 is the input latch control..."ACK"...active low
                 ' pb7 is the output latch control..active low
                 ' pc0-2 are set to input for optical sensor monitor
Out &H180, &HFF  ' set data lines high
Out &H181, &HFF  ' *ack,*stb,*cs1,*cs2,*ps,*rst,wr*,rd* = 1

    'the following initializes the DIO 96 card used to
    'control the abrasive application with the vibe motor
    
Port_A_DIO = &H1A       'bit1=hi : rotary table off
                        'bit3=hi : rising edge triggers shaker 0
                        'bit4=hi : rising edge triggers shaker 1
Out &H1A3, &H80         'set DIO 96 port A to all outputs
Out &H1A0, Port_A_DIO   'grit application="off"
                        'rotary table run="false" (hi turns it off)
                        'Port_A_DIO
End Sub

'********************************************************
Public Sub reset()                 'checked
'********************************************************

'RESET line on chip toggle LOW:  This is a HARDWARE RESET
'both parts share the reset line and are reset

Out &H181, portb And &HFB  'portb bit_2=low
Out &H181, portb Or &H4    'portb bit_2=high
delay (1000000)            'wait 1.5ms minimum prior to
                           'reading status
            
Status = readstatus(0)
  If (Status = &HC4) Or (Status = &H84) Then
    Traj_form.Status_Main.Caption = Hex$(Status)    ' displays status on Traj_form
    Traj_form.Status_Main.Refresh                   ' refresh display of status
  Else
    Traj_form.Status_Main.Caption = "not reset"     ' displays status on Traj_form
    Traj_form.Status_Main.Refresh                   ' refresh display of status
  End If
   
Status = readstatus(1)
  If (Status = &HC4) Or (Status = &H84) Then
    Traj_form.Status_Polish.Caption = Hex$(Status)  ' displays status on Traj_form
    Traj_form.Status_Polish.Refresh                 ' refresh display of status
  Else
    Traj_form.Status_Polish.Caption = "not reset"   ' displays status on Traj_form
    Traj_form.Status_Polish.Refresh                 ' refresh display of status
  End If
                                                
End Sub
'***********************************************************
Public Sub Busybit(channel As Byte)                 'checked
'***********************************************************

Dim busy As Byte

busy_loop: busy = readstatus(channel) And &H1                      'only want bit zero
          ' If emulation_flag = True Then GoTo jmp_out_busy_loop    'skip out if no servo card
           If busy = 1 Then GoTo busy_loop

jmp_out_busy_loop:

End Sub

'***********************************************************
Public Function readstatus(channel As Byte) As Integer
'***********************************************************
                                                    'checked
 busmode "command"
 readstatus = readbus1(channel)
 busmode "data"
 
End Function
'**************************************************************
Public Function Traj_Done(channel As Byte) As Boolean
'**************************************************************

Dim Status As Byte

  Status = readstatus(channel)
  Traj_Done = CBool(&H4 And Status)    ' true if trajectory is done, else false

End Function
'************************************************************
Public Function readbus1(channel As Byte) As Integer          'checked
'************************************************************
 
 chipselect channel, "low"        'set either cs#1 or cs#2 to low
 readselect "low"                 'set read low on 628's
 inputlatchA                      'latch input to port A..*stb low
    readbus1 = Inp(&H180)         'read value on port
 readselect "high"                'set read hi
 chipselect channel, "high"       'set cs' high
 
End Function
'*********************************************************
Public Sub WriteCom(channel As Byte, command As Byte)           'checked
'*********************************************************
 Busybit (channel)
 busmode "command"
 writebus1 channel, command
 busmode "data"

End Sub
'************************************************************
Public Sub writebus1(channel As Byte, b As Byte)                 'checked
'************************************************************
   
 Out (&H180), b               'write value into port A output latch
 outputlatchA "low"           'take port A output latch out of tristate
 chipselect channel, "low"            'set *CS on channel low
 writeselect "low"            'set *WR low on 628's
 writeselect "high"           'set *WR high
 chipselect channel, "high"           'set *CS high
 outputlatchA "high"          'put port A output latch in tristate
 
End Sub
'************************************************************
Public Sub writebus2(channel As Byte, Word As Long)               'checked
'************************************************************

Dim hi As Byte, lo As Byte
    hi = CByte(Word \ 256)               'gen hi byte
    lo = CByte(Word - CLng(hi) * 256)    'gen low byte
    
Busybit (channel)                        'wait until LM628 not busy
writebus1 channel, hi                    'write hi byte
writebus1 channel, lo                    'write lo byte

End Sub
'**************************************************************
Public Sub readselect(mode As String)         'atomic/checked
'**************************************************************

  If mode = "low" Then
     portb = portb And &HFE   'set *RD low
  End If
   
  If mode = "high" Then
     portb = portb Or &H1     'set *RD bit high to data mode
  End If
  
Out &H181, portb        'update readselect

End Sub
'****************************************************************
Public Sub writeselect(mode As String)          'atomic/checked
'****************************************************************
 
  If mode = "low" Then
     portb = portb And &HFD   'set *wr bit low
  End If
   
  If mode = "high" Then
     portb = portb Or &H2     'set *wr bit high to data mode
  End If
  
Out &H181, portb              'update writeselect

End Sub
'**********************************************************
Public Sub busmode(mode As String)      'atomic/checked
'**********************************************************
 
  If mode = "command" Then
     portb = portb And &HF7   'set ps bit low to command mode
  End If
   
  If mode = "data" Then
     portb = portb Or &H8     'set ps bit high to data mode
  End If
   
Out &H181, portb              'update portb *PS mode

End Sub
'***************************************************************************
Public Sub chipselect(channel As Byte, mode As String)    'atomic/checked
'***************************************************************************

  If mode = "low" Then
     portb = portb And (255 - 16 * 2 ^ channel) 'set *chipselect low
  End If
   
  If mode = "high" Then
     portb = portb Or (16 * 2 ^ channel)        'set *chipselect high
  End If
    
Out &H181, portb        'update portc chipselect line

End Sub

'*************************************************************
Public Sub inputlatchA()                'atomic/checked
'*************************************************************
 
     portb = portb And &HBF   'set *stb bit low
     Out &H181, portb
     
     delay (100)
     
     portb = portb Or &H40    'set *stb bit high
     Out &H181, portb

End Sub
'*************************************************************
Public Sub outputlatchA(mode As String)  'atomic/checked
'*************************************************************

  If mode = "low" Then
     portb = portb And &H7F   'set *ack bit low
  End If
  
  If mode = "high" Then
     portb = portb Or &H80    'set *ack bit high
  End If
  
  Out &H181, portb
  
End Sub

'***********************************************************************************************************************
Public Sub LTRJ(channel As Byte, Acceleration As Long, Velocity As Long, Position As Long)                          'checked
'***********************************************************************************************************************
    
Dim Bug_Position As Long       'bug fix variable
Dim Bug_Velocity As Long       'wipes out variable in
Dim Bug_Acceleration As Long   'calling routine corresponding
                               'to position
                               'everything was ok with
                               'vel and acc till later
                               'fooling with captions
                               'they took a shit too!
    
WriteCom channel, &H1F                       'LTRJ load traj command
        
    Busybit channel
    writebus1 channel, &H0                   'write upper traj control word
    writebus1 channel, &H2A                  'write lower traj control word
 
    Bug_Acceleration = Acceleration
    Convert_Word_To_Bytes Bug_Acceleration
    writebus4 channel
    
    Bug_Velocity = Velocity
    Convert_Word_To_Bytes Bug_Velocity
    writebus4 channel
     
     
    Bug_Position = Position
    Convert_Word_To_Bytes Bug_Position
    writebus4 channel
    
   
End Sub



'************************************************************
Public Sub writebus4(channel As Byte)
'************************************************************
    
Busybit (channel)                                 'wait until LM628 not busy
writebus1 channel, byte_parameter_array(3)
writebus1 channel, byte_parameter_array(2)
Busybit (channel)
writebus1 channel, byte_parameter_array(1)
writebus1 channel, byte_parameter_array(0)


End Sub
'*************************************************
Public Sub Convert_Word_To_Bytes(Word32 As Long)
'*************************************************

Dim neg_flag As Boolean
neg_flag = False

If Word32 < 0 Then
   Word32 = Abs(Word32) - 1
   neg_flag = True
End If

For I = 0 To 3
  byte_parameter_array(3 - I) = CByte(Word32 \ 2 ^ ((3 - I) * 8))
  Word32 = Word32 - byte_parameter_array(3 - I) * 2 ^ ((3 - I) * 8)
Next I

If neg_flag Then
   byte_parameter_array(3) = Not (byte_parameter_array(3))
   byte_parameter_array(2) = Not (byte_parameter_array(2))
   byte_parameter_array(1) = Not (byte_parameter_array(1))
   byte_parameter_array(0) = Not (byte_parameter_array(0))
End If

End Sub


'************************************************************************************
Public Sub LFIL(channel As Byte, Diff_Clk As Byte, P As Long, I As Long, D As Long, I_Limit As Long)
'************************************************************************************
 
WriteCom channel, &H1E           'LFIL load filter coeff command

    Busybit (channel)            'wait until LM628 not busy
    writebus1 channel, Diff_Clk          'derivative undersampling divisor
    writebus1 channel, &HF               'filter control word..load all params
    writebus2 channel, P         'proportional term
    writebus2 channel, I         'integral term
    writebus2 channel, D         'derivative term
    writebus2 channel, I_Limit   'integration limit

Busybit (channel)
WriteCom channel, &H4             'update filter coeff UDF

End Sub
'**************************************************************
Public Sub STT(channel As Byte)
'**************************************************************

WriteCom channel, &H1         'START motion control command
                              'on current channel
End Sub
'**************************************************************
Public Sub StopDrive(channel As Byte)
'**************************************************************

WriteCom channel, &H1F       'LTRJ load trajectory command

Busybit (channel)
writebus1 channel, &H4       'was &h4  'write upper control word
writebus1 channel, &H0       'write lower control word
STT channel

End Sub
'***********************************************************
Public Sub De_Energize(channel As Byte)    ' turn off motor
'***********************************************************

StopDrive 0                  ' smooth stop
StopDrive 1

loop0: If Traj_Done(channel) = False Then GoTo loop0 ' wait until traj done (smooth stop)

WriteCom channel, &H1F       ' LTRJ load trajectory command

Busybit (channel)
writebus1 channel, &H1       ' write upper control word
writebus1 channel, &H0       ' write lower control word
STT channel

End Sub
'***********************************************************
Public Sub DFH(channel As Byte)                         'checked
'***********************************************************

WriteCom channel, &H2              ' DEFINE HOME command

End Sub
'************************************************************
Public Sub RSTI(channel As Byte, mask As Byte)
'************************************************************

WriteCom channel, &H1D              'RESET INTERUPTS on current channel
Busybit (channel)
writebus1 channel, &H0              'first byte is not used
writebus1 channel, mask             'RESET selected INTERUPTS on
                            'current channel
End Sub
'*************************************************************
Public Sub RdSigs(channel As Byte)                 'checked
'*************************************************************

WriteCom channel, &HC                               ' Issue RSIG command (Read Signals)
Busybit (channel)
signalhi(channel) = readbus1(channel)                ' read hi byte signals reg
signallo(channel) = readbus1(channel)                ' read lo byte signals reg

End Sub
'**************************************************************
Public Sub SIP(channel As Byte)                            'checked
'**************************************************************

WriteCom channel, &H3                   'SET INDEX POSITION  command

End Sub
'***********************************************************
Public Function RDRP(channel As Byte) As Long  'read REAL position /checked
'***********************************************************

WriteCom channel, &HA         'issue RDRP command (read real pos)
RDRP = readbus4(channel)

End Function
'************************************************************
Public Function RDIP(channel As Byte) As Long ' read INDEX POSITION  /checked
'************************************************************

WriteCom channel, &H9        'issue RDIP command (read desired pos)
RDIP = readbus4(channel)

End Function
'************************************************************
Public Function RDDV(channel As Byte) As Long ' read desired velocity
'************************************************************
WriteCom channel, &H7        'issue RDDV command (read desired pos)
RDDV = readbus4(channel)

End Function
'************************************************************
Public Function RDRV(channel As Byte) As Long ' read real velocity
'************************************************************

WriteCom channel, &HB        'issue RDRV command ( read real pos )
RDRV = readbus2(channel)

End Function

'*************************************************************
Public Function RDDP(channel As Byte) As Long ' read desired position/checked
'**************************************************************
WriteCom channel, &H8        'issue RDDP command (read desired pos)
RDDP = readbus4(channel)

End Function

'****************************************************************************
Public Function readbus2(channel As Byte) As Long ' read 2 bytes in sequence
'****************************************************************************
                                   
Dim b(0 To 3) As Byte
Dim hiword As Long
Dim loword As Long

Busybit (channel)                                     'wait till LM628 not busy
b(3) = readbus1(channel)                              'read high byte
b(2) = readbus1(channel)                              'read high byte

b(1) = 0                                              'dummy up to zero to use
b(0) = 0                                              'same conversion as readbus4

hiword = b(3) * 2 ^ 8 + b(2)
loword = b(1) * 2 ^ 8 + b(0)
readbus2 = val_long("&h" + hex_word(hiword) + hex_word(loword))

End Function

'****************************************************************************
Public Function readbus4(channel As Byte) As Long ' read 4 bytes in sequence
'****************************************************************************
                                   'checked
Dim b(0 To 3) As Byte
Dim hiword As Long
Dim loword As Long

Busybit (channel)                            'wait till LM628 not busy
b(3) = readbus1(channel)                              'read high byte
b(2) = readbus1(channel)                              'read high byte

Busybit (channel)
b(1) = readbus1(channel)                              'read high byte
b(0) = readbus1(channel)                              'read high byte

hiword = b(3) * 2 ^ 8 + b(2)
loword = b(1) * 2 ^ 8 + b(0)
readbus4 = val_long("&h" + hex_word(hiword) + hex_word(loword))

End Function
'**********************************************************
Public Function hex_word(x As Long) As String
'**********************************************************

  x = x + 2 ^ 16
  hex_word = Right(Hex$(x), 4)

End Function
'**********************************************************
Public Function val_long(a$) As Long
'**********************************************************

  If ((Left(a$, 6) = "&h0000") And (Val("&h" & Mid(a$, 7, 1)) > 7)) Then
    val_long = Val("&h1" + Right(a$, 4)) - 2 ^ 16
  Else
    val_long = Val(a$)
  End If

End Function

'********************************************************
Public Sub delay(j)
'********************************************************

  For I = 1 To j
  Next I
End Sub

'***********************************************************
Public Sub Exit_Routine()
'***********************************************************

   Rotary_Drive_Switch "off"
   StopDrive 0
   StopDrive 1
   De_Energize 0
   De_Energize 1


   End

End Sub

'****************************************************
Public Sub Trigger_Apply_Grit(bank As Byte)
'****************************************************
If bank = 0 Then
    HW_Timer_Interval_Write 0, Application_Interval_0, 0
End If

If bank = 1 Then
    HW_Timer_Interval_Write 1, Application_Interval_1, 0
End If

End Sub

'****************************************************
Public Sub Rotary_Drive_Switch(switch As String)
'****************************************************

If switch = "on" Then
   Port_A_DIO = Port_A_DIO And &HFD   'bit 1 set lo
Else
   Port_A_DIO = Port_A_DIO Or &H2     'bit 2 set hi
End If
Out &H1A0, Port_A_DIO

End Sub













